   
#ifndef __USB_CDC_DEV_D__
  #define __USB_CDC_DEV_D__
#endif

#include "usb_fce.h"

PRIVATE struct __attribute__ ((packed))  {
  /* Module of arrive packets of Host */
  struct __attribute__ ((packed)) {
         BYTE Data[CDC_DATA_IN_EP_SIZE];
         int buffer_size;
          }Tmp;
         unsigned char cp_ptr;
         unsigned char cmd_ptr;     
         BYTE cdc_rx_len;
}USB_Transmission_Receive;

PRIVATE struct _transmission_ {
  /* Module of in/out packets from USB_Transmision_Receive */
  struct __attribute__ ((packed)){
         BYTE Data[CDC_DATA_IN_EP_SIZE];
         BYTE Command[CDC_DATA_IN_EP_SIZE];
          }Data;

         BYTE size;
         BYTE size2;
         unsigned char ready;
         int time;            
}Transmission;
struct _transmission_ USB_Received;
struct _transmission_ USB_Transmiter;
struct _transmission_ USB_Receiver;
static struct _transmission_ Transmission;


PRIVATE struct __attribute__ ((packed)) {
 struct __attribute__ ((packed)){
        char * message_1; 
        char * message_2;
        char * message_3;
      }Message;
 struct __attribute__ ((packed)) {
         int sign_1;
         int sign_2;
         int sign_3;
      }MSign;    
 struct __attribute__ ((packed)) {
         int first;
         int second;
      }Tmp;         
}USB_Status_Messages;


PRIVATE struct __attribute__ ((packed)) {
         byte NewLine;
         byte CommandKey; 
 struct __attribute__ ((packed)) {
         int time;
         int mode;
         int swt;
      }Tmp;              
}Keys;

#ifndef __USB_CDC_Status_Led__
  #define __USB_CDC_Status_Led__
#endif

PRIVATE struct __attribute__ ((packed)) {
 struct __attribute__ ((packed)) {
      volatile unsigned int *Port;
      volatile unsigned int *Tris;
        BOOL blink;
        int Led;
       }Led;
 struct __attribute__ ((packed)) {
        int time;
       }Tmp;         
}USB_Status;


void BlinkUSBStatus(void);
void USBStatusMessages(BYTE);
void Config_Key(void);
int PcharUsbUsart();
void LookUp(byte);
void ProcessIO2(void);
void USB_Interface(void);

void BlinkUSBStatus()
{
 if(USB_Status.Led.blink == TRUE)
   {
     if(!USB_Status.Tmp.time)
       {
           if (*USB_Status.Led.Port == PORTA && PORTA != __No__Used__ && TRISA != __No__Used__) { USB_Status.Led.Tris = uintptr &TRISA; }
            if (*USB_Status.Led.Port == PORTB && PORTB != __No__Used__ && TRISB != __No__Used__) { USB_Status.Led.Tris = uintptr &TRISB; }
              if (*USB_Status.Led.Port == PORTC && PORTC != __No__Used__ && TRISC != __No__Used__) { USB_Status.Led.Tris = uintptr &TRISC; }
                if (*USB_Status.Led.Port == PORTD && PORTD != __No__Used__ && TRISD != __No__Used__) { USB_Status.Led.Tris = uintptr &TRISD; }

                   // 189; // -> ERROR /Bad Ports/

                Init_Port(*USB_Status.Led.Port,USB_Status.Led.Led,"digital"); 
                Config_OUT(*USB_Status.Led.Tris, USB_Status.Led.Led);
                USB_Status.Tmp.time = 1;
        }

             static WORD led_count = 0;

           if(led_count == 0)
             {
               led_count = 10000U;
             }
               led_count--;

      if(USBSuspendControl == 1)
        {
          if(led_count == 0)
            {   
              Bit_Set(*USB_Status.Led.Port, USB_Status.Led.Led);
              Bit_Toogle(*USB_Status.Led.Port, USB_Status.Led.Led);
            }
        }
           else
              {
                   if(USBDeviceState == DETACHED_STATE)
                     {
                       // mLED_Both_Off();
                        USBStatusMessages(0xff);
                     }
                     else if(USBDeviceState == ATTACHED_STATE)
                     {
                       // mLED_Both_On();
                        USBStatusMessages(0xff);
                     }
                     else if(USBDeviceState == POWERED_STATE)
                     {
                       // mLED_Only_1_On();
                     }
                     else if(USBDeviceState == DEFAULT_STATE)
                     {
                        Bit_Clr(*USB_Status.Led.Port, USB_Status.Led.Led);
                        USBStatusMessages(0xff);
                     }
                     else if(USBDeviceState == ADDRESS_STATE)
                     {
                        if(led_count == 0)
                          {
                             Bit_Toogle(*USB_Status.Led.Port, USB_Status.Led.Led);
                          }
                        USBStatusMessages(0x1a);
                     }
                     else if(USBDeviceState == CONFIGURED_STATE)
                     {
                        if(led_count == 0)
                          {
                             Bit_Toogle(*USB_Status.Led.Port, USB_Status.Led.Led);
                          }
                        USBStatusMessages(0x1a);
                     }
              }
   }
}

void USBStatusMessages(BYTE sign)
{
       USB_Status_Messages.Tmp.second = USB_Status_Messages.Tmp.first;
         
       switch(sign)
             {
                 case 0xff:
                       USB_Status_Messages.Message.message_1 = "PC - Odpojeny !";
                       USB_Status_Messages.MSign.sign_1 = 1;
                       USB_Status_Messages.Tmp.first = 1;
                     break;
                 case 0x1a:
                       USB_Status_Messages.Message.message_1 = "PC - Pripojeny!";
                       USB_Status_Messages.MSign.sign_1 = 2;
                       USB_Status_Messages.Tmp.first = 2;
                     break;
             }

     if( (USB_Status_Messages.MSign.sign_1 == 2 ||  USB_Status_Messages.MSign.sign_1 == 1) && (USB_Status_Messages.Tmp.second != USB_Status_Messages.Tmp.first) )
       { /*
            USB_Status_Messages.Message.message_1
         */ 

           if(USB_Status_Messages.MSign.sign_1 == 2)
             { /*
                  USB_Status_Messages.Message.message_1
               */    
             }
       }

}


void USB_Interface()
{        
         USB_Received.time = 0;
         USB_Received.ready = 0;
         USB_Received.size = 0;

         USB_Transmission_Receive.cp_ptr = 0;
         USB_Transmission_Receive.cmd_ptr = 0;
         USB_Transmission_Receive.Tmp.buffer_size = 64;

         USB_Status.Tmp.time = 0;

         InitializeSystem();

         AD1CON1 = 0x00E0; // Internal counter triggers conversion //*
         AD1CHS  = 0x0000; // Connect AN0 as positive input
         AD1CSSL = 0;
         AD1CON3 = 0x0F00; // Sample time = 15Tad, Tad = Tcy
         AD1CON2 = 0x003C; // Set AD1IF after every 16 samples
         AD1CON1bits.ADON = 1; // turn ADC ON //*

         /* ------ Init timer 1 ------------------------------------
              T1CONbits.TON=0;
              T1CONbits.TCKPS=0b11;
              PR1=31250;
              IEC0bits.T1IE = 1; //Enable Timer1 interrupts
              T1CONbits.TON = 1; //Start Timer1 with prescaler settings at 1:1 and 
         */
         /* ------ Init timer 2 ------------------------------------
              __builtin_write_OSCCONL(OSCCON & 0xBF); // Unlock Registers 
              _T2CKR=14; // PIN RP5 as TMR2 input
              __builtin_write_OSCCONL(OSCCON | 0x40); Lock Registers  
              T2CONbits.TCS=1; // externa pin!!
              T2CONbits.TON = 1; //Start Timer1 with prescaler settings at 1:1 and 
         */
}

void ProcessIO(void)
{ 
   BlinkUSBStatus();
   if((USBDeviceState < CONFIGURED_STATE)||(USBSuspendControl==1)) return;
   if(USBUSARTIsTxTrfReady())
     {
          if (USB_Received.ready == 0)
             {
                USB_Received.size = getsUSBUSART(USB_Transmission_Receive.Tmp.Data,USB_Transmission_Receive.Tmp.buffer_size); 

                 if (USB_Received.size > 0)
                    {
                        BYTE cdc_rx_len;              
                           for(cdc_rx_len = 0; cdc_rx_len < USB_Received.size; cdc_rx_len++)
                              {
                                 if(Keys.Tmp.swt == 2)
                                   {
                                      USB_Received.Data.Command[cdc_rx_len] = USB_Transmission_Receive.Tmp.Data[cdc_rx_len];
                                   } else {
                                            USB_Received.Data.Data[cdc_rx_len] = USB_Transmission_Receive.Tmp.Data[cdc_rx_len];
                                          }       
                              }     
                         USB_Received.ready = 1;
                         USB_Transmission_Receive.cp_ptr = 0;
                    }
              }
          if(USB_Received.ready)
            {
                  BlinkUSBStatus(); 
                  /* 
                     Prijat dta s uloen v poli USB_Received.Data.Data. Pocet prijatch dt je uloen v USB_Received.size.
                     Dalie spracovanie - metda naprklad s "unsigned char*" parametrom + pocet prijatch dt.
                  */   
			}

                if (USB_Received.ready)
                   {
                       USB_Received.ready = 0;
                       USB_Received.size = 0; 
                       USB_Transmission_Receive.cp_ptr = 0;

                      for(cdc_rx_len = 0; cdc_rx_len < CDC_DATA_IN_EP_SIZE; cdc_rx_len++)
                         {
                            USB_Received.Data.Data[cdc_rx_len] = 0;
                            USB_Received.Data.Command[cdc_rx_len] = 0;
                            USB_Transmission_Receive.Tmp.Data[cdc_rx_len] = 0;
                         }
                   }
     }
    CDCTxService();
}


#ifndef _Diall_
  #define _Diall_ 0xac2f01
  #warning "Created by Diallix (C)"
#endif

