
#ifndef __USB_DESCRIPTORS_C
#define __USB_DESCRIPTORS_C
 
#include "./USB/usb.h"
#include "./USB/usb_function_cdc.h"

#if defined(__18CXX)
#pragma romdata
#endif


ROM USB_DEVICE_DESCRIPTOR device_dsc=
{
    0x12,
    USB_DESCRIPTOR_DEVICE,
    0x0200,
    CDC_DEVICE,
    0x00,
    0x00,
    USB_EP0_BUFF_SIZE,
    0x04D8,
    0x000A,
    0x0100,
    0x01,
    0x02,
    0x00,
    0x01
};

ROM BYTE configDescriptor1[]={
    0x09,//sizeof(USB_CFG_DSC),
    USB_DESCRIPTOR_CONFIGURATION,
    67,0,
    2,
    1,
    0,
    _DEFAULT | _SELF,
    50,
						
    9,
    USB_DESCRIPTOR_INTERFACE,
    0,
    0,
    1,
    COMM_INTF,
    ABSTRACT_CONTROL_MODEL,
    V25TER,
    0,

    sizeof(USB_CDC_HEADER_FN_DSC),
    CS_INTERFACE,
    DSC_FN_HEADER,
    0x10,0x01,

    sizeof(USB_CDC_ACM_FN_DSC),
    CS_INTERFACE,
    DSC_FN_ACM,
    USB_CDC_ACM_FN_DSC_VAL,

    sizeof(USB_CDC_UNION_FN_DSC),
    CS_INTERFACE,
    DSC_FN_UNION,
    CDC_COMM_INTF_ID,
    CDC_DATA_INTF_ID,

    sizeof(USB_CDC_CALL_MGT_FN_DSC),
    CS_INTERFACE,
    DSC_FN_CALL_MGT,
    0x00,
    CDC_DATA_INTF_ID,
    0x07,/*sizeof(USB_EP_DSC)*/
    USB_DESCRIPTOR_ENDPOINT,
    _EP01_IN,
    _INTERRUPT,                    
    0x08,0x00,      
    0x02,

    9,
    USB_DESCRIPTOR_INTERFACE,
    1,
    0,
    2,
    DATA_INTF,
    0,
    NO_PROTOCOL,
    0,
    0x07,
    USB_DESCRIPTOR_ENDPOINT,
    _EP02_OUT,
    _BULK,
    0x40,0x00,
    0x00,
    0x07,/*sizeof(USB_EP_DSC)*/
    USB_DESCRIPTOR_ENDPOINT,
    _EP02_IN,
    _BULK,
    0x40,0x00,
    0x00,
};

#ifndef __USB_CDC_DEV_D__

  ROM struct{BYTE bLength;BYTE bDscType;WORD string[1];}sd000={
  sizeof(sd000),USB_DESCRIPTOR_STRING,{0x0409}};

  ROM struct{BYTE bLength;BYTE bDscType;WORD string[25];}sd001={
  sizeof(sd001),USB_DESCRIPTOR_STRING,
  {'D','i','a','l','l','i','x',' ',
  'L','a','b','.'
  }};

  ROM struct{BYTE bLength;BYTE bDscType;WORD string[25];}sd002={
  sizeof(sd002),USB_DESCRIPTOR_STRING,
  {'C','D','C',' ','R','S','-','2','3','2',' ',
  'D','i','a','l','l','i','x','.','n','e','t'}
  };
#endif

ROM BYTE *ROM USB_CD_Ptr[]=
{
    (ROM BYTE *ROM)&configDescriptor1
};

ROM BYTE *ROM USB_SD_Ptr[USB_NUM_STRING_DESCRIPTORS]=
{
    (ROM BYTE *ROM)&sd000,
    (ROM BYTE *ROM)&sd001,
    (ROM BYTE *ROM)&sd002
};

#pragma code
#endif

